package image

import (
	"context"
	"encoding/json"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/dynamix-golang-sdk/v14/internal/validators"
)

// CreateRequest struct to create image
type CreateRequest struct {
	// Name of the image
	// Required: true
	Name string `url:"name" json:"name" validate:"required"`

	// URL where to download media from
	// Required: true
	URL string `url:"url" json:"url" validate:"required,url"`

	// Boot type of image
	// Should be one of:
	//	- bios
	//	- UEFI
	// Required: true
	BootType string `url:"boottype" json:"boottype" validate:"required,imageBootType"`

	// Image type
	// Should be one of:
	//	- linux
	//	- windows
	//	- or other
	// Required: true
	ImageType string `url:"imagetype" json:"imagetype" validate:"required,imageType"`

	// ID of the chosen storage policy
	// Required: true
	StoragePolicyID uint64 `url:"storage_policy_id" json:"storage_policy_id" validate:"required"`

	// Select a network interface naming pattern for your Linux machine. eth - onboard, ens - pci slot naming
	// Should be:
	//  - eth
	//  - ens (default value)
	// Required: false
	NetworkInterfaceNaming string `url:"networkInterfaceNaming,omitempty" json:"networkInterfaceNaming,omitempty" validate:"omitempty,networkInterfaceNaming"`

	// Does this machine supports hot resize
	// Required: false
	HotResize bool `url:"hotresize,omitempty" json:"hotresize,omitempty"`

	// Optional username for the image
	// Required: false
	Username string `url:"username,omitempty" json:"username,omitempty"`

	// Optional password for the image
	// Required: false
	Password string `url:"password,omitempty" json:"password,omitempty"`

	// Account ID to make the image exclusive
	// Required: false
	AccountID uint64 `url:"accountId,omitempty" json:"accountId,omitempty"`

	// Username for upload binary media
	// Required: false
	UsernameDL string `url:"usernameDL,omitempty" json:"usernameDL,omitempty"`

	// Password for upload binary media
	// Required: false
	PasswordDL string `url:"passwordDL,omitempty" json:"passwordDL,omitempty"`

	// Storage endpoint provider ID
	// Required: false
	SEPID uint64 `url:"sepId,omitempty" json:"sepId,omitempty"`

	// Pool for image create
	// Required: false
	PoolName string `url:"poolName,omitempty" json:"poolName,omitempty"`

	// Bootable image or not
	// Required: false
	Bootable bool `url:"bootable,omitempty" json:"bootable,omitempty"`
}

type asyncWrapperCreateRequest struct {
	CreateRequest
	AsyncMode bool `url:"asyncMode"`
}

// CreateImage creates image from a media identified by URL
func (i Image) CreateImage(ctx context.Context, req CreateRequest) (uint64, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return 0, validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/image/createImage"

	syncReq := asyncWrapperCreateRequest{CreateRequest: req, AsyncMode: false}

	res, err := i.client.DecortApiCall(ctx, http.MethodPost, url, syncReq)
	if err != nil {
		return 0, err
	}

	result, err := strconv.ParseUint(string(res), 10, 64)
	if err != nil {
		return 0, err
	}

	return result, nil
}

// AsyncCreate creates image from a media identified by URL in async mode
func (i Image) AsyncCreateImage(ctx context.Context, req CreateRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/image/createImage"

	asyncReq := asyncWrapperCreateRequest{CreateRequest: req, AsyncMode: true}

	res, err := i.client.DecortApiCall(ctx, http.MethodPost, url, asyncReq)
	if err != nil {
		return " ", err
	}

	var taskID string

	err = json.Unmarshal(res, &taskID)
	if err != nil {
		return "", err
	}

	return taskID, nil
}
